<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_hotelRatePlanTax ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_hotelRatePlanTax extends AbstractStructArrayBase
{
    /**
     * The Tax
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_hotelRatePlanTax[]
     */
    public $Tax;
    /**
     * Constructor method for ArrayOfJPSOAP_hotelRatePlanTax
     * @uses ArrayOfJPSOAP_hotelRatePlanTax::setTax()
     * @param \StructType\JPSOAP_hotelRatePlanTax[] $tax
     */
    public function __construct(array $tax = array())
    {
        $this
            ->setTax($tax);
    }
    /**
     * Get Tax value
     * @return \StructType\JPSOAP_hotelRatePlanTax[]|null
     */
    public function getTax()
    {
        return $this->Tax;
    }
    /**
     * This method is responsible for validating the values passed to the setTax method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTax method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTaxForArrayConstraintsFromSetTax(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJPSOAP_hotelRatePlanTaxTaxItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_hotelRatePlanTaxTaxItem instanceof \StructType\JPSOAP_hotelRatePlanTax) {
                $invalidValues[] = is_object($arrayOfJPSOAP_hotelRatePlanTaxTaxItem) ? get_class($arrayOfJPSOAP_hotelRatePlanTaxTaxItem) : sprintf('%s(%s)', gettype($arrayOfJPSOAP_hotelRatePlanTaxTaxItem), var_export($arrayOfJPSOAP_hotelRatePlanTaxTaxItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Tax property can only contain items of type \StructType\JPSOAP_hotelRatePlanTax, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Tax value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_hotelRatePlanTax[] $tax
     * @return \ArrayType\ArrayOfJPSOAP_hotelRatePlanTax
     */
    public function setTax(array $tax = array())
    {
        // validation for constraint: array
        if ('' !== ($taxArrayErrorMessage = self::validateTaxForArrayConstraintsFromSetTax($tax))) {
            throw new \InvalidArgumentException($taxArrayErrorMessage, __LINE__);
        }
        $this->Tax = $tax;
        return $this;
    }
    /**
     * Add item to Tax value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_hotelRatePlanTax $item
     * @return \ArrayType\ArrayOfJPSOAP_hotelRatePlanTax
     */
    public function addToTax(\StructType\JPSOAP_hotelRatePlanTax $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_hotelRatePlanTax) {
            throw new \InvalidArgumentException(sprintf('The Tax property can only contain items of type \StructType\JPSOAP_hotelRatePlanTax, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Tax[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JPSOAP_hotelRatePlanTax|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JPSOAP_hotelRatePlanTax|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JPSOAP_hotelRatePlanTax|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JPSOAP_hotelRatePlanTax|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JPSOAP_hotelRatePlanTax|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Tax
     */
    public function getAttributeName()
    {
        return 'Tax';
    }
}
